## 2. Document versioning

Detail how you would store several versioned, text-based documents, and present a schema for your solution.

It should be able to show:
   - the document in its current state
   - the document at any point in its history
   - the changes made between two versions

Strive for disk space efficiency.

**Answer**

As we want to strive for disk space efficiency we can easily see that storing the whole documents every time is not a solution. This being the case, we are going to store only the differences that are made to a single document.

#### DB schema
The schema of the DB will be the following:
![Versioned documents DB schema](images/versioned-documents-db-schema.png)

In `document` table the latest document information will be kept. Keeping only the latest version of the document gives us the ability to faster retrieve the document in its current state. It has one to many relationship with `document_version` table.
In `document_version` table the information for a different version of a document will be kept. It has one to many relationship with `document_change` table. Additional index by `created_at` which will be used to retrieve document at any point in its history and changes made between two versions (if used by specified time interval).
In `document_change` table the changes from a document version will be kept.

The most interesting part is the generation of the changes for `document_change` table which will be used for space efficiency. It has `operation_type` column which will have one of three values - `insertion`, `deletion` or `equality`, the `affected_text` will be the string that is affected during a change.

#### Work algorithm

1. If a document is created - calculate the checksum, create new `document` record.
2. If a document is updated - calculate the checksum.
    
    2.1 If the calculated checksum is the same as the checksum of the current latest document -> do nothing as it is the same document and it wasn't updated
    2.2 If the calculated checksum is different
        
      - Generate the changes between the current latest document and the new one
      - Replace on storage the current latest document with the new one
      - Update the `document` record
      - Create new `document_version` record
      - Save the generated changes as `document_change` records.

The changes between two documents will be generated based on the [Myer's diff algorithm](https://neil.fraser.name/writing/diff/myers.pdf). It's considered to be one of the best general-purpose diff algorithms. The changes can be generated in more human-readable form in order to have a better visualization of the changes made between two versions. A library like [diff-match-patch](https://github.com/google/diff-match-patch) can be used for changes generation.

#### Get document at any point in its history

To get a document version at any point in time all changes for all versions to the specified moment of time will be retrieved. Executing all of the changes with opposite operation type (`insertion` becomes `deletion` and vice versa) onto the latest document version will produce the document at the specified point in time. Reversing the operation type is needed because the generated changes are from document A to document B. Changing the direction from document B to document A requires the opposite operations to be executed to get the wanted document version properly.

#### Get changes made between two versions

To get the changes between two versions all changes between the two document versions should be retrieved. To display the difference between the two documents the content of the first document and the content of the second document should be generated by applying the changes respectively. Then, visualization of the changes between the two documents can be made for better understanding of the change.

Example of displaying the document changes:
![Changes between two documents](images/document-changes.png)
